<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.prize_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
import {getList, getDetail, add, update, remove} from "@/api/activities/prize";
import {mapGetters} from "vuex";
import func from "@/util/func";

export default {
  data() {
    return {
      form: {},
      query: {},
      loading: true,
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 0
      },
      selectionList: [],
      option: {
        height:'auto',
        calcHeight: 30,
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        viewBtn: true,
        selection: true,
        dialogClickModal: false,
        column: [
          {
            label: "奖品类型",
            prop: "prizeType",
            rules: [{
              required: true,
              message: "请输入奖品类型",
              trigger: "blur"
            }],
            type: "select",
            dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=PrizeTypeEnum",
            props: {
              label: "name",
              value: "value"
            },
            dataType: "number",
          },
          {
            label: "奖品图片",
            prop: "prizeImageShow",
            addDisplay: false,
            viewDisplay: false,
            editDisplay: false,
            type: 'upload',
            listType: 'picture-img',
          },
          {
            label: "实物、优惠券奖品id",
            prop: "realPrizeId",
            hide: true,
            addDisplay: false,
            viewDisplay: false,
            editDisplay: false,
          },
          {
            label: "商品",
            prop: "goodsInfoId",
            hide: true,
            span: 24,
            addDisplay: false,
            viewDisplay: false,
            editDisplay: false,
            type: "select",
            remote: true,
            props: {
              label: 'goodsName',
              value: 'id'
            },
            dicUrl: '/api/mall/goodsinfo/page?goodsName={{key}}',
            dicFormatter: function (res) {
              return res.data.records;
            },
            dataType: "number",
            rules: [
              {
                required: true,
                message: '请选择商品',
                trigger: 'blur'
              }
            ]
          },
          {
            label: "奖品名字",
            prop: "prizeName",
            rules: [{
              required: true,
              message: "请输入奖品名字",
              trigger: "blur"
            }]
          },
          {
            label: "奖品数量(值)",
            prop: "prizeValue",
            rules: [{
              required: true,
              message: "请输入奖品值（数量）",
              trigger: "blur"
            }]
          },
          {
            label: "中奖几率(%)",
            labelWidth: 110,
            prop: "ratio",
            type: 'number',
            rules: [{
              required: true,
              message: "请输入中奖几率",
              trigger: "blur"
            }]
          },
          {
            label: "当前命中",
            prop: "currentNum",
            addDisplay: false,
            editDisplay: false,
          },
          {
            label: "最大中奖数 0：代表不限制",
            prop: "maxNum",
            hide: true,
            addDisplay: false,
            viewDisplay: false,
            editDisplay: false,
            rules: [{
              required: true,
              message: "请输入最大中奖数 0：代表不限制",
              trigger: "blur"
            }]
          },
          {
            label: '奖品图片',
            prop: 'prizeImage',
            type: 'upload',
            listType: 'picture-img',
            loadText: '上传中，请稍等',
            accept: 'image/png, image/jpeg',
            fileSize: 500,
            tip: '只能上传jpg/png文件，且不超过500kb',
            span: 24,
            hide: true,
            propsHttp: {
              res: 'data',
              url: 'link',
            },
            action: "/api/blade-resource/oss/endpoint/put-file-attach"
          },
        ]
      },
      data: []
    };
  },
  watch: {
    'form.prizeType'() {
      const prizeType = func.toInt(this.form.prizeType);
      this.$refs.crud.option.column.filter(item => {
        if (item.prop === "goodsInfoId") {
          item.addDisplay = prizeType === 2;
        }
      });
    },
  },
  created() {
    this.option.column[3].change = function (column) {
      console.log(column)
    }.bind(this);
  },
  computed: {
    ...mapGetters(["permission"]),
    permissionList() {
      return {
        addBtn: this.vaildData(this.permission.prize_add, false),
        viewBtn: this.vaildData(this.permission.prize_view, false),
        delBtn: this.vaildData(this.permission.prize_delete, false),
        editBtn: this.vaildData(this.permission.prize_edit, false)
      };
    },
    ids() {
      let ids = [];
      this.selectionList.forEach(ele => {
        ids.push(ele.id);
      });
      return ids.join(",");
    }
  },
  methods: {
    rowSave(row, done, loading) {
      add(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        loading();
        window.console.log(error);
      });
    },
    rowUpdate(row, index, done, loading) {
      update(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        loading();
        console.log(error);
      });
    },
    rowDel(row) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
    },
    handleDelete() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
    },
    beforeOpen(done, type) {
      if (["edit", "view"].includes(type)) {
        getDetail(this.form.id).then(res => {
          this.form = res.data.data;
        });
      }
      done();
    },
    searchReset() {
      this.query = {};
      this.onLoad(this.page);
    },
    searchChange(params, done) {
      this.query = params;
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    selectionChange(list) {
      this.selectionList = list;
    },
    selectionClear() {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    currentChange(currentPage){
      this.page.currentPage = currentPage;
    },
    sizeChange(pageSize){
      this.page.pageSize = pageSize;
    },
    refreshChange() {
      this.onLoad(this.page, this.query);
    },
    onLoad(page, params = {}) {
      this.loading = true;
      getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
        const data = res.data.data;
        this.page.total = data.total;
        this.data = data.records;
        this.data.forEach(e => {
          e.prizeImageShow = e.prizeImage;
        })
        this.loading = false;
        this.selectionClear();
      });
    }
  }
};
</script>

<style>
</style>
